
package nc.impl.uapbd.mate_change.mate_change_h;

import java.util.Arrays;

import org.apache.commons.lang3.ArrayUtils;

import nc.bs.framework.common.NCLocator;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.SuperVO;
import nc.vo.pub.ISuperVO;
import nc.vo.pub.IVOMeta;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.model.meta.entity.bill.IBillMeta;
import nc.vo.trade.pub.HYBillVO;
import nc.vo.pubapp.pattern.model.entity.bill.AbstractBill;
import nccloud.bs.excel.IXChangeContext;
import nccloud.bs.excel.plugin.AbstractImportProceeWithContext;
import nc.vo.axj.matechange.MateChangeBVO;
import nc.vo.axj.matechange.MateChangeHVO;
import nc.vo.axj.matechange.AggMateChangeVO;
import nc.itf.uapbd.mate_change.mate_change_h.IMateChangeHVOService;

public class AggMateChangeVOImportProcess extends AbstractImportProceeWithContext {
	
	@Override
	protected void processBillWithContext(Object vo, IXChangeContext changcontext) throws BusinessException {
		AggMateChangeVO targetVO = (AggMateChangeVO)vo;
		targetVO.getParentVO().setStatus(VOStatus.NEW);

		MateChangeBVO[] mateChangeBVOs = (MateChangeBVO[])targetVO.getChildren(MateChangeBVO.class);
		if(mateChangeBVOs!=null && mateChangeBVOs.length>0){
			Arrays.stream(mateChangeBVOs).forEach(subvo->{
				subvo.setStatus(VOStatus.NEW);
			});
		}
  		getService().initDefaultData(targetVO.getParentVO());
		getService().saveAggMateChangeVO(targetVO);
	}
	
	private IMateChangeHVOService getService() {
		return NCLocator.getInstance().lookup(IMateChangeHVOService.class);
	}

}
