package nc.impl.uapbd.mate_change.mate_change_h;

import java.util.Map;
import java.util.Optional;
import java.util.Set;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.ArrayList;
import java.util.stream.Collectors;
import java.util.UUID;
import java.lang.String;
import java.util.stream.Stream;

import com.hazelcast.spi.impl.operationservice.impl.operations.Backup;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.vo.axj.matechange.MateChangeHiVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDateTime;
import nc.uap.utils.InSQLCreator;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.beanutils.PropertyUtils;


import nc.vo.pub.BusinessException;
import nc.vo.pub.BusinessRuntimeException;
import nc.vo.pub.SuperVO;
import nc.vo.pub.VOStatus;
import nc.codeplatform.framework.service.ServiceSupport;

import nc.pub.billcode.vo.BillCodeContext;

import nc.vo.axj.matechange.MateChangeBVO;
import nc.vo.axj.matechange.MateChangeHVO;
import nc.vo.bd.material.MaterialConvertVO;
import nc.vo.bd.material.MaterialVO;
import nc.vo.axj.matechange.AggMateChangeVO;
import nc.itf.bd.material.baseinfo.IMaterialBaseInfoQueryService;
import nc.itf.bd.material.baseinfo.IMaterialBaseInfoService;
import nc.itf.uapbd.mate_change.mate_change_h.IMateChangeHVOService;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.vo.pub.pf.BillStatusEnum;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.jdbc.ColumnProcessor;

public class MateChangeHVOServiceImpl extends ServiceSupport implements IMateChangeHVOService {


    @Override
    public AggMateChangeVO[] listAggMateChangeVOByPk(String... pks) throws BusinessException {
        return listAggMateChangeVOByPk(false, pks);
    }

    @Override
    public AggMateChangeVO[] listAggMateChangeVOByPk(boolean blazyLoad, String... pks) throws BusinessException {
        return dao.listByPksWithOrder(AggMateChangeVO.class, pks, blazyLoad);
    }

    @Override
    public AggMateChangeVO findAggMateChangeVOByPk(String pk) throws BusinessException {
        return dao.findByPk(AggMateChangeVO.class, pk, false);
    }

    @Override
    public AggMateChangeVO[] listAggMateChangeVOByCondition(String condition) throws BusinessException {
        return listAggMateChangeVOByCondition(condition, new String[]{"pk_mate_change_h"});
    }

    @Override
    public AggMateChangeVO[] listAggMateChangeVOByCondition(String condition, String[] orderPath) throws BusinessException {
        return dao.listByCondition(AggMateChangeVO.class, condition, false, false, orderPath);
    }

    @Override
    public MateChangeHVO[] listMateChangeHVOByPk(String... pks) throws BusinessException {
        return dao.listByPk(MateChangeHVO.class, pks, true);
    }

    @Override
    public MateChangeHVO findMateChangeHVOByPk(String pk) throws BusinessException {
        return dao.findByPk(MateChangeHVO.class, pk, true);
    }

    @Override
    public MateChangeHVO[] listMateChangeHVOByCondition(String condition) throws BusinessException {
        return listMateChangeHVOByCondition(condition, new String[]{"pk_mate_change_h"});
    }

    @Override
    public MateChangeHVO[] listMateChangeHVOByCondition(String condition, String[] orderPath) throws BusinessException {
        return dao.listByCondition(MateChangeHVO.class, condition, false, false, orderPath);
    }

    @Override
    public String[] listMateChangeHVOPkByCond(String condition) throws BusinessException {
        return listMateChangeHVOPkByCond(condition, new String[]{"pk_mate_change_h"});
    }

    @Override
    public String[] listMateChangeHVOPkByCond(String condition, String[] orderPath) throws BusinessException {
        if (StringUtils.isEmpty(condition)) {
            condition = " 1 = 1 ";
        }
        StringBuilder sql = new StringBuilder();
        sql.append(" select pk_mate_change_h from ").append(MateChangeHVO.getDefaultTableName());
        sql.append(" where ").append(condition);
        if (ArrayUtils.isNotEmpty(orderPath)) {
            sql.append(" order by ").append(StringUtils.join(orderPath, ", "));
        }
        return (String[]) dao.getBaseDAO().executeQuery(sql.toString(), (rs) -> {
            List<String> pks = new ArrayList<>();
            while (rs.next()) {
                pks.add(rs.getString(1));
            }
            return pks.toArray(new String[0]);
        });
    }

    @Override
    public void initDefaultData(MateChangeHVO vo) {
        if (vo.getAttributeValue("pk_group") == null) {
            vo.setAttributeValue("pk_group", InvocationInfoProxy.getInstance().getGroupId());
        }
        if (vo.getAttributeValue("billmaker") == null) {
            vo.setAttributeValue("billmaker", InvocationInfoProxy.getInstance().getUserId());
        }
        if (vo.getAttributeValue("maketime") == null) {
            vo.setAttributeValue("maketime", new UFDateTime(InvocationInfoProxy.getInstance().getBizDateTime()));
        }
        if (vo.getAttributeValue("billtype") == null) {
            vo.setAttributeValue("billtype", "AMCA");
        }
        if (vo.getAttributeValue("approvestatus") == null) {
            vo.setAttributeValue("approvestatus", BillStatusEnum.FREE.toIntValue());
        }
    }

    @Override
    public AggMateChangeVO preAddAggMateChangeVO(AggMateChangeVO vo, Map<String, Object> userJson) throws BusinessException {

        getMainVO(vo).setStatus(VOStatus.NEW);
        initDefaultData((MateChangeHVO) getMainVO(vo));

        //ҪжǷ
        Map<String, String> data = userJson != null && userJson.get("data") != null ? (Map<String, String>) userJson.get("data") : null;
        if (data != null && data.size() > 0) {
            String parentKey = data.get("parentKey");
            String parentPk = data.get("parentPk");
            getMainVO(vo).setAttributeValue(parentKey, parentPk);
        }

        //voı
        BillCodeContext billCodeContext = getBillCodeContext("axjmate_change");
        if (billCodeContext == null) {
            throw new BusinessException("ǰ򲻴ڣ뵽-ȫ֡ڵǷ" + "axjmate_change");
        }
        if (billCodeContext.isPrecode()) {
            String pk_group = InvocationInfoProxy.getInstance().getGroupId();
            String code = getBillcodeManage().getPreBillCode_RequiresNew("axjmate_change", pk_group, pk_group);
            getMainVO(vo).setAttributeValue("code", code);
        }

        return vo;
    }

    @Override
    public AggMateChangeVO preAddAggMateChangeVO(Map<String, Object> userJson) throws BusinessException {
        AggMateChangeVO result = null;

        MateChangeHVO mainvo = new MateChangeHVO();
        //Ĭֵ
        initDefaultData(mainvo);
        AggMateChangeVO aggvo = new AggMateChangeVO();
        aggvo.setParent(mainvo);
        result = aggvo;
        return preAddAggMateChangeVO(result, userJson);
    }

    @Override
    public AggMateChangeVO preEditAggMateChangeVO(String pk) throws BusinessException {
        return dao.findByPk(AggMateChangeVO.class, pk, false);
    }

    @Override
    public AggMateChangeVO copyAggMateChangeVO(String pk) throws BusinessException {

        AggMateChangeVO vo = dao.findByPk(AggMateChangeVO.class, pk, false);

        getMainVO(vo).setPrimaryKey(null);
        getMainVO(vo).setStatus(VOStatus.NEW);

        getMainVO(vo).setAttributeValue("srcbilltype", null);
        getMainVO(vo).setAttributeValue("srcbillid", null);

        getMainVO(vo).setAttributeValue("code", null);
        getMainVO(vo).setAttributeValue("name", null);
        //voı
        BillCodeContext billCodeContext = getBillCodeContext("axjmate_change");
        if (billCodeContext == null) {
            throw new BusinessException("ǰ򲻴ڣ뵽-ȫ֡ڵǷ" + "axjmate_change");
        }
        if (billCodeContext.isPrecode()) {
            String pk_group = InvocationInfoProxy.getInstance().getGroupId();
            String code = getBillcodeManage().getPreBillCode_RequiresNew("axjmate_change", pk_group, pk_group);
            getMainVO(vo).setAttributeValue("code", code);
        }
        getMainVO(vo).setAttributeValue("approvestatus", BillStatusEnum.FREE.toIntValue());
        getMainVO(vo).setAttributeValue("billmaker", InvocationInfoProxy.getInstance().getUserId());
        getMainVO(vo).setAttributeValue("approver", null);
        getMainVO(vo).setAttributeValue("approvenote", null);
        getMainVO(vo).setAttributeValue("approvedate", null);
        //ϢΪ
        getMainVO(vo).setAttributeValue("creator", null);
        getMainVO(vo).setAttributeValue("creationtime", null);
        getMainVO(vo).setAttributeValue("modifier", null);
        getMainVO(vo).setAttributeValue("modifiedtime", null);
        getMainVO(vo).setAttributeValue("maketime", new UFDateTime(InvocationInfoProxy.getInstance().getBizDateTime()));

        MateChangeBVO[] mateChangeBVOs = (MateChangeBVO[]) vo.getChildren(MateChangeBVO.class);
        if (mateChangeBVOs != null && mateChangeBVOs.length > 0) {
            Arrays.stream(mateChangeBVOs).forEach(subvo -> {
                subvo.setPrimaryKey(null);
                subvo.setStatus(VOStatus.NEW);
                subvo.setAttributeValue("srcbilltype", null);
                subvo.setAttributeValue("srcbillid", null);
                subvo.setAttributeValue("rowno", null);
                subvo.setAttributeValue("srcrowno", null);
            });
        }
        return vo;
    }

    @Override
    public AggMateChangeVO[] saveAggMateChangeVO(AggMateChangeVO vo) throws BusinessException {
        checkMaterialRepeat(vo);// Уظ

        String pk = getVOPrimaryKey(vo);
        setDefaultVal(vo);
        if (StringUtils.isEmpty(pk)) {
            return dao.insert(vo); //
        } else {
            return dao.update(vo); //
        }
    }

    /**
     * ǰ
     *
     * @param vos
     */
    private void setBillCode(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isNotEmpty(vos)) {
            for (AggMateChangeVO vo : vos) {
                String pk = getVOPrimaryKey(vo);
                if (StringUtils.isEmpty(pk)) {
                    BillCodeContext billCodeContext = getBillCodeContext("axjmate_change");
                    String pk_group = InvocationInfoProxy.getInstance().getGroupId();
                    if (billCodeContext != null && !billCodeContext.isPrecode()) {
                        if (getMainVO(vo).getAttributeValue("code") == null) {
                            String code = getBillcodeManage().getBillCode_RequiresNew("axjmate_change", pk_group, pk_group, getMainVO(vo));
                            getMainVO(vo).setAttributeValue("code", code);
                        }
                    } else {
                        String code = (String) getMainVO(vo).getAttributeValue("code");
                        getBillcodeManage().commitPreBillCode("axjmate_change", pk_group, pk_group, code);
                    }
                }
            }
        }
    }

    /**
     * ǰϢ
     *
     * @param vos
     */
    private void setAuditInfo(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isNotEmpty(vos)) {
            UFDateTime now = new UFDateTime();
            for (AggMateChangeVO vo : vos) {
                String pk = getVOPrimaryKey(vo);
                if (StringUtils.isEmpty(pk)) {
                    //ô˴ʱ
                    getMainVO(vo).setAttributeValue("creator", InvocationInfoProxy.getInstance().getUserId());
                    getMainVO(vo).setAttributeValue("creationtime", now);
                    getMainVO(vo).setAttributeValue("maketime", now);
                    getMainVO(vo).setAttributeValue("billmaker", InvocationInfoProxy.getInstance().getUserId()); // Ƶ
                    getMainVO(vo).setAttributeValue("modifier", null);
                    getMainVO(vo).setAttributeValue("modifiedtime", null);
                } else {
                    //޸޸ʱ
                    getMainVO(vo).setAttributeValue("modifier", InvocationInfoProxy.getInstance().getUserId());
                    getMainVO(vo).setAttributeValue("modifiedtime", now);
                    getMainVO(vo).setAttributeValue("lastmaketime", now);
                }
            }
        }
    }

    /**
     * ǰһЩĬֵ
     *
     * @param vos
     */
    private void setDefaultVal(AggMateChangeVO... vos) throws BusinessException {
        setBillCode(vos);
        setAuditInfo(vos);
        //Ĭֵ
    }

    // б༭
    @Override
    public AggMateChangeVO[] saveAggMateChangeVO(AggMateChangeVO[] vos) throws BusinessException {
        if (ArrayUtils.isEmpty(vos)) {
            return new AggMateChangeVO[0];
        }
        checkMaterialRepeat(vos);// Уظ

        setDefaultVal(vos); // Ĭֵ
        List<String> pks = Arrays.stream(vos).filter(v -> getMainVO(v).getStatus() == VOStatus.DELETED)
                .map(v -> getMainVO(v).getPrimaryKey()).collect(Collectors.toList()); // ɾ
        if (pks == null || pks.size() == 0) {
            return dao.save(vos, true);
        }
        AggMateChangeVO[] deleteVOs = dao.listByPk(AggMateChangeVO.class, pks.toArray(new String[0]));
        for (int i = 0; i < deleteVOs.length; i++) {
            SuperVO mainVO = getMainVO(deleteVOs[i]);
            // ɾʱУ鵥״̬
            Integer approveStatus = (Integer) mainVO.getAttributeValue("approvestatus");
            if (approveStatus != null && !approveStatus.equals(-1)) {
                throw new BusinessException("" + (i + 1) + "ŵݴʧܣ״̬ȷɾ");
            }
            // ɾʱ˵ݺ
            String code = (String) mainVO.getAttributeValue("code");
            if (StringUtils.isNotEmpty(code)) {
                String pk_group = InvocationInfoProxy.getInstance().getGroupId();
                getBillcodeManage().returnBillCodeOnDelete("axjmate_change", pk_group, pk_group, code, deleteVOs[i]);
            }
        }
        return dao.save(vos, true);
    }

    @Override
    public AggMateChangeVO[] deleteAggMateChangeVOs(Map<String, String> tsMap) throws BusinessException {
        AggMateChangeVO[] vos = dao.listByPk(AggMateChangeVO.class, tsMap.keySet().toArray(new String[0]));
        validate(vos, tsMap);
        String pk_group = InvocationInfoProxy.getInstance().getGroupId();
        Arrays.stream(vos).forEach(vo -> {
            String code = (String) getMainVO(vo).getAttributeValue("code");
            try {
                getBillcodeManage().returnBillCodeOnDelete("axjmate_change", pk_group, pk_group, code, vo);
            } catch (BusinessException e) {
                ExceptionUtils.wrapException(e.getMessage(), e);
            }
        });
        dao.delete(vos, true);
        return vos;
    }

    //У  tsУ  ύУ
    private void validate(AggMateChangeVO[] vos, Map<String, String> tsMap) throws BusinessException {

        Boolean isPass = true;
        String error = "";    //Ϣ
        if (ArrayUtils.isEmpty(vos)) {
            isPass = false;
        }

        for (int i = 0; i < vos.length; i++) {
            SuperVO mainvo = vos[i].getParentVO();
            UFDateTime ts = (UFDateTime) mainvo.getAttributeValue("ts");
            if (!StringUtils.equals(tsMap.get(mainvo.getPrimaryKey()), ts.toString())) {
                isPass = false;
                break;
            }
            Integer approvestatus = (Integer) mainvo.getAttributeValue("approvestatus");
            if (approvestatus == null || approvestatus != BillStatusEnum.FREE.toIntValue()) {
                error += "" + (i + 1) + "ŵݴʧܣ״̬ȷɾ\n";
            }
        }
        if (!isPass) {
            throw new BusinessException("ѱ޸Ļɾˢºԣ");
        }
        if (!"".equals(error)) {
            throw new BusinessException(error);
        }
    }

    @Override
    public <T> T[] loadTreeData(Class<T> clazz, Map<String, Object> userJson) throws BusinessException {
        String condition = "dr = 0 ";
        return dao.listByCondition(clazz, condition, false);
    }

    @Override
    public String[] queryChildPksByParentId(Class childClazz, String parentId) throws BusinessException {
        String cond = " pk_mate_change_h = '" + parentId + "' ";
        SuperVO[] vos = (SuperVO[]) dao.listByCondition(childClazz, cond, false);
        if (vos == null || vos.length == 0) {
            return new String[0];
        }
        return Stream.of(vos).map(vo -> vo.getPrimaryKey()).toArray(String[]::new);
    }


    public SuperVO[] queryChildVOByPks(Class childClazz, String[] pks) throws BusinessException {
        return (SuperVO[]) dao.listByPk(childClazz, pks, false);
    }

    /**
     * ύǰУ:
     * 鵥״̬
     *
     * @throws BusinessException
     */
    private void validateCommitAggMateChangeVO(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isEmpty(vos)) {
            return;
        }
        List<AggMateChangeVO> list = Arrays.stream(vos)
                .filter(item -> item.getParentVO() != null)
                .filter(item -> {
                    Integer status = (Integer) item.getParentVO().getAttributeValue("approvestatus");
                    return status == null || status != BillStatusEnum.FREE.toIntValue() && status != BillStatusEnum.NOPASS.toIntValue();
                }).map(item -> item)
                .collect(Collectors.toList());
        if (list == null || list.size() == 0) {
            return;
        }
        String errors = "";
        for (AggMateChangeVO vo : list) {
            errors += "ݺţ[" + vo.getParentVO().getAttributeValue("code") + "]ύʧܣʧԭ򣺵״̬ȷ顣\n";
        }
        throw new BusinessException(errors);
    }

    /**
     * ջǰУ:
     * 鵥״̬
     *
     * @throws BusinessException
     */
    private void validateUnCommitAggMateChangeVO(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isEmpty(vos)) {
            return;
        }
        List<AggMateChangeVO> list = Arrays.stream(vos)
                .filter(item -> item.getParentVO() != null)
                .filter(item -> {
                    Integer status = (Integer) item.getParentVO().getAttributeValue("approvestatus");
                    return status == null || status == BillStatusEnum.FREE.toIntValue();
                }).map(item -> item)
                .collect(Collectors.toList());
        if (list == null || list.size() == 0) {
            return;
        }
        String errors = "";
        for (AggMateChangeVO vo : list) {
            errors += "ݺţ[" + vo.getParentVO().getAttributeValue("code") + "]ջʧܣʧԭ򣺵״̬ȷ顣\n";
        }
        throw new BusinessException(errors);
    }

    @Override
    public Object commitAggMateChangeVO(String actionName, Map<String, String> tsMap, Object assign) throws BusinessException {
        AggMateChangeVO[] vos = dao.listByPk(AggMateChangeVO.class, getAllPks(tsMap), false);
        validateTs(tsMap, vos);
        //ύǰУ鼰ҵ߼
        validateCommitAggMateChangeVO(vos);
        Map<String, Object> res = this.execFlows(actionName, "AMCA", assign, vos);
        //ύҵ߼
        return res;
    }

    @Override
    public Object batchCommitAggMateChangeVO(String actionName, Map<String, String> tsMap) throws BusinessException {
        AggMateChangeVO[] vos = dao.listByPk(AggMateChangeVO.class, getAllPks(tsMap), false);
        validateTs(tsMap, vos);
        //ύǰУ鼰ҵ߼
        validateCommitAggMateChangeVO(vos);
        Map<String, Object> res = this.execFlows(actionName, "AMCA", vos);
        //ύҵ߼
        return res;
    }

    @Override
    public Object uncommitAggMateChangeVO(String actionName, Map<String, String> tsMap) throws BusinessException {
        AggMateChangeVO[] vos = dao.listByPk(AggMateChangeVO.class, getAllPks(tsMap), false);
        validateTs(tsMap, vos);
        //ջǰУ鼰ҵ߼
        validateUnCommitAggMateChangeVO(vos);
        Map<String, Object> res = this.execFlows(actionName, "AMCA", vos);
        //ջغҵ߼
        return res;
    }

    @Override
    public Object batchUncommitAggMateChangeVO(String actionName, Map<String, String> tsMap) throws BusinessException {
        AggMateChangeVO[] vos = dao.listByPk(AggMateChangeVO.class, getAllPks(tsMap), false);
        validateTs(tsMap, vos);
        //ջǰУ鼰ҵ߼
        validateUnCommitAggMateChangeVO(vos);
        Map<String, Object> res = this.execFlows(actionName, "AMCA", vos);
        //ջغҵ߼
        return res;
    }

    @Override
    public AggMateChangeVO[] callbackSAVEBASE(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isEmpty(vos)) {
            return null;
        }
        return this.saveAggMateChangeVO(vos);

    }


    @Override
    public AggMateChangeVO[] callbackSAVE(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isEmpty(vos)) {
            return null;
        }
        //ͬ״̬״̬(ֻύʱҪֶ״̬״̬Ѹ)
        Arrays.stream(vos).forEach(v -> {
            v.getParent().setAttributeValue("approvestatus", BillStatusEnum.COMMIT.toIntValue());
        });
        return this.saveAggMateChangeVO(vos);

    }


    @Override
    public AggMateChangeVO[] callbackUNSAVE(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isEmpty(vos)) {
            return null;
        }
        return this.saveAggMateChangeVO(vos);

    }


    @Override
    public AggMateChangeVO[] callbackAPPROVE(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isEmpty(vos)) {
            return null;
        }
        AggMateChangeVO[] saveAggMateChangeVO = this.saveAggMateChangeVO(vos);
        handleMaterialChange(vos);
        return saveAggMateChangeVO;

    }


    @Override
    public AggMateChangeVO[] callbackUNAPPROVE(AggMateChangeVO... vos) throws BusinessException {
        if (ArrayUtils.isEmpty(vos)) {
            return null;
        }
        //ͨĵջ
        checkUnApprove(vos);
        return this.saveAggMateChangeVO(vos);

    }


    @Override
    public BillCodeContext getBillCodeContext(String coderuleid) throws BusinessException {
        return super.getBillCodeContext(coderuleid);
    }

    @Override
    public BillCodeContext getBillCodeContext(String coderuleid, String pkgroup, String pkorg) throws BusinessException {
        return super.getBillCodeContext(coderuleid, pkgroup, pkorg);
    }

    /**
     * Уظظδɵĵظ
     *
     * @param vos
     * @throws BusinessException
     */
    private void checkMaterialRepeat(AggMateChangeVO... vos) throws BusinessException {
        BaseDAO baseDAO = dao.getBaseDAO();
        Set<String> materiaSet = new HashSet<>();
        for (AggMateChangeVO vo : vos) {
            if (vo.getParentVO().getStatus() == VOStatus.DELETED)
                continue; // ɾֱӹ
            MateChangeBVO[] childrenVO = vo.getAllMateChangeBVO();
            for (MateChangeBVO bvo : childrenVO) {
                String pk_material = bvo.getPk_material(); // 
                if (materiaSet.contains(pk_material)) {
                    MaterialVO[] m = NCLocator.getInstance().lookup(IMaterialBaseInfoQueryService.class)
                            .queryDataByPks(new String[]{pk_material});
                    throw new BusinessException("ظϡ" + m[0].getName() + "");
                } else {
                    materiaSet.add(pk_material);
                }
            }
        }
        InSQLCreator creator = new InSQLCreator();
        String materiaSql = creator.getInSQL(materiaSet.toArray(new String[materiaSet.size()]));
        String sql = " SELECT mate.name FROM axj_mate_change_h h "
                + " JOIN axj_mate_change_b b ON h.pk_mate_change_h = b.pk_mate_change_h "
                + " JOIN bd_material mate ON mate.pk_material = b.pk_material "
                + " WHERE h.approvestatus <>  1   AND b.pk_material IN (" + materiaSql + ") ";
        for (AggMateChangeVO vo : vos) {
            if (vo.getParentVO().getStatus() == VOStatus.DELETED)
                continue; // ɾֱӹ
            MateChangeHVO parentVO = vo.getParentVO();
            String primaryKey = parentVO.getPk_mate_change_h();
            String endSql = "";
            if (StringUtils.isBlank(primaryKey)) {
                // 

            } else {
                // ޸
                endSql = " and h.pk_mate_change_h <> '" + primaryKey + "' ";
            }

            endSql = sql + endSql + " GROUP BY b.pk_material,mate.name HAVING COUNT(1) >0 ";
            List<String> repeatData = (List) baseDAO.executeQuery(endSql, new ColumnListProcessor());
            if (repeatData != null && repeatData.size() > 0) {
                throw new BusinessException("ϡ" + String.join(",", repeatData) + "ڽеıȴ");
            }
        }

    }

    /**
     * Ϣͨ˵ 
     *
     * @param vos
     */
    private void handleMaterialChange(AggMateChangeVO... vos) throws BusinessException {
        IMaterialBaseInfoQueryService baseInfoQueryService = NCLocator.getInstance().lookup(IMaterialBaseInfoQueryService.class);
        IMaterialBaseInfoService baseInfoService = NCLocator.getInstance().lookup(IMaterialBaseInfoService.class);
        Map<String, MaterialVO> updateMap = new HashMap<>();
        for (AggMateChangeVO aggMateChangeVO : vos) {
            MateChangeHVO parentVO = aggMateChangeVO.getParentVO();
            if (parentVO.getApprovestatus() == BillStatusEnum.APPROVED.toIntValue()) {
                // ͨ˵ 
                MateChangeBVO[] children = aggMateChangeVO.getAllMateChangeBVO();
                String[] materialArray = Arrays.stream(children).map(MateChangeBVO::getPk_material).toArray(String[]::new);
                MaterialVO[] materialVOs = baseInfoQueryService.queryDataByPks(materialArray); //B֪ܲܲ ͣõ 鲻Ҫ취

                if (materialVOs != null && materialVOs.length > 0) {
                    Map<String, MaterialVO> sourceMaterial = Arrays.stream(materialVOs).collect(Collectors.toMap(MaterialVO::getPk_material, v -> v));
                    for (MateChangeBVO bvo : children) {
                        // 20230816  Dzz ޸ǰ ݰ汾Ϣ
                        backupMaterialVersion(bvo);
                        MaterialVO materialVO = sourceMaterial.get(bvo.getPk_material());
                        if (StringUtils.isNotBlank(bvo.getName())) materialVO.setName(bvo.getName()); //
                        if (StringUtils.isNotBlank(bvo.getMaterialspec()))
                            materialVO.setMaterialspec(bvo.getMaterialspec()); //Ҏ
                        if (StringUtils.isNotBlank(bvo.getMaterialtype()))
                            materialVO.setMaterialtype(bvo.getMaterialtype());//̖
                        if (StringUtils.isNotBlank(bvo.getPk_brand()))
                            materialVO.setPk_brand(bvo.getPk_brand());// Ʒ
                        if (StringUtils.isNotBlank(bvo.getPk_measdoc())) {
                            MaterialConvertVO[] materialconvert = materialVO.getMaterialconvert();


                            if (materialconvert != null && materialconvert.length > 0) {
                                Optional<String> optional = Arrays.stream(materialconvert).map(MaterialConvertVO::getPk_measdoc).filter(bvo.getPk_measdoc()::equals).findAny();
                                if (optional.isPresent()) {
                                    // Ѿл ù
                                } else {
                                    //û һ
                                    // oӋ
                                    List<MaterialConvertVO> old = new ArrayList<>(Arrays.asList(materialconvert));
                                    for (MaterialConvertVO oldConvertVO : old) {

                                        oldConvertVO.setIsstockmeasdoc(new UFBoolean(false));
                                        oldConvertVO.setIssalemeasdoc(new UFBoolean(false));
                                        oldConvertVO.setIsretailmeasdoc(new UFBoolean(false));
                                        oldConvertVO.setIspumeasdoc(new UFBoolean(false));
                                        oldConvertVO.setIsprodmeasdoc(new UFBoolean(false));
                                        oldConvertVO.setStatus(VOStatus.UPDATED);
                                    }
                                    MaterialConvertVO convertVO = new MaterialConvertVO();
                                    convertVO.setPk_measdoc(bvo.getPk_measdoc()); //oӋI
                                    convertVO.setPk_material(bvo.getPk_material());//I
                                    convertVO.setMeasrate(StringUtils.isNotBlank(bvo.getMeasrate()) ? bvo.getMeasrate() : "1/1");///o
                                    convertVO.setIsstockmeasdoc(new UFBoolean(true));
                                    convertVO.setIsstorebalance(new UFBoolean(true));
                                    convertVO.setIssalemeasdoc(new UFBoolean(true));
                                    convertVO.setIsretailmeasdoc(new UFBoolean(true));
                                    convertVO.setIspumeasdoc(new UFBoolean(true));
                                    convertVO.setIsprodmeasdoc(new UFBoolean(true));
                                    convertVO.setIspiecemangage(new UFBoolean(false));
                                    convertVO.setFixedflag(new UFBoolean(true));
                                    convertVO.setDr(0);
                                    convertVO.setStatus(VOStatus.NEW);
                                    old.add(convertVO);
                                    materialVO.setMaterialconvert(old.toArray(new MaterialConvertVO[0]));
                                }
                            } else {
                                // oӋ
                                MaterialConvertVO convertVO = new MaterialConvertVO();
                                convertVO.setPk_measdoc(bvo.getPk_measdoc()); //oӋI
                                convertVO.setPk_material(bvo.getPk_material());//I
                                convertVO.setMeasrate(StringUtils.isNotBlank(bvo.getMeasrate()) ? bvo.getMeasrate() : "1/1");///o
                                convertVO.setIsstockmeasdoc(new UFBoolean(true));
                                convertVO.setIsstorebalance(new UFBoolean(true));
                                convertVO.setIssalemeasdoc(new UFBoolean(true));
                                convertVO.setIsretailmeasdoc(new UFBoolean(true));
                                convertVO.setIspumeasdoc(new UFBoolean(true));
                                convertVO.setIsprodmeasdoc(new UFBoolean(true));
                                convertVO.setIspiecemangage(new UFBoolean(false));
                                convertVO.setFixedflag(new UFBoolean(true));
                                convertVO.setDr(0);
                                materialVO.setMaterialconvert(new MaterialConvertVO[]{convertVO});
                            }
                        }
                        if (StringUtils.isNotBlank(bvo.getPk_mattaxes()))
                            materialVO.setPk_mattaxes(bvo.getPk_mattaxes()); //˰
                        if (StringUtils.isNotBlank(bvo.getDef1())) materialVO.setDef1(bvo.getDef1());
                        if (StringUtils.isNotBlank(bvo.getDef2())) materialVO.setDef2(bvo.getDef2()); //ʽ
                        if (StringUtils.isNotBlank(bvo.getDef3())) materialVO.setDef3(bvo.getDef3());
                        if (StringUtils.isNotBlank(bvo.getDef4())) materialVO.setDef4(bvo.getDef4());
                        if (StringUtils.isNotBlank(bvo.getDef5())) materialVO.setDef5(bvo.getDef5());
                        if (StringUtils.isNotBlank(bvo.getDef6())) materialVO.setDef6(bvo.getDef6());
                        if (StringUtils.isNotBlank(bvo.getDef7())) materialVO.setDef7(bvo.getDef7());
                        if (StringUtils.isNotBlank(bvo.getDef8())) materialVO.setDef8(bvo.getDef8());
                        if (StringUtils.isNotBlank(bvo.getDef9())) materialVO.setDef9(bvo.getDef9());
                        if (StringUtils.isNotBlank(bvo.getDef10())) materialVO.setDef10(bvo.getDef10());
                        if (StringUtils.isNotBlank(bvo.getDef11())) materialVO.setDef11(bvo.getDef11());
                        if (StringUtils.isNotBlank(bvo.getDef12())) materialVO.setDef12(bvo.getDef12()); //˰շ
                        if (StringUtils.isNotBlank(bvo.getDef13())) materialVO.setDef13(bvo.getDef13());
                        if (StringUtils.isNotBlank(bvo.getDef14())) materialVO.setDef14(bvo.getDef14());
                        if (StringUtils.isNotBlank(bvo.getDef15())) materialVO.setDef15(bvo.getDef15());
                        if (StringUtils.isNotBlank(bvo.getDef16())) materialVO.setDef16(bvo.getDef16());
                        if (StringUtils.isNotBlank(bvo.getDef17())) materialVO.setDef17(bvo.getDef17());
                        if (StringUtils.isNotBlank(bvo.getDef18())) materialVO.setDef18(bvo.getDef18());
                        if (StringUtils.isNotBlank(bvo.getDef19())) materialVO.setDef19(bvo.getDef19());
                        if (StringUtils.isNotBlank(bvo.getDef20())) materialVO.setDef20(bvo.getDef20());

                        if (StringUtils.isNotBlank(bvo.getEnablestate()))
                            materialVO.setEnablestate(Integer.valueOf(bvo.getEnablestate()));//˰
                        baseInfoService.updateMaterial(materialVO);
                    }
                }
            } else {
                continue;
            }
        }

    }

    private void backupMaterialVersion(MateChangeBVO mateChangeBVO ) throws BusinessException {
        String pk_material = mateChangeBVO.getPk_material();
        BaseDAO dao = new BaseDAO();
        MateChangeHiVO data = (MateChangeHiVO)dao.executeQuery(" select * from bd_material where pk_material ='" + pk_material + "' ", new BeanProcessor(MateChangeHiVO.class));
        data.setPk_mate_change_h(mateChangeBVO.getPk_mate_change_h());
        data.setPk_mate_change_b(mateChangeBVO.getPk_mate_change_b());
        data.setCreationtime(new UFDateTime());
        dao.insertVO(data);
    }

    private void checkUnApprove(AggMateChangeVO... vos) throws BusinessException {
        BaseDAO baseDAO = dao.getBaseDAO();
        for (AggMateChangeVO aggMateChangeVO : vos) {
            List<Integer> approvestatus = (List) baseDAO.executeQuery("select approvestatus from axj_mate_change_h where pk_mate_change_h = '" + aggMateChangeVO.getPrimaryKey() + "' ", new ColumnListProcessor());
            if (approvestatus.get(0) == BillStatusEnum.APPROVED.toIntValue()) {
                throw new BusinessException("ͨϱֹջ");
            }
        }
    }

}
