package nc.bs.pub.action;

import java.util.Arrays;

import nc.bs.framework.common.NCLocator;
import nc.bs.pub.compiler.IWorkFlowRet;
import nc.vo.pub.BusinessException;
import nc.vo.pub.compiler.PfParameterVO;
import nc.vo.pub.VOStatus;
import nc.vo.uap.pf.PFBusinessException;
import nc.vo.pubapp.pattern.model.entity.bill.AbstractBill;
import nc.vo.pubapp.pattern.model.meta.entity.bill.IBillMeta;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nccloud.commons.lang.StringUtils;
import nc.codeplatform.framework.service.AbstractPfScriptAction;
import nc.vo.axj.matechange.AggMateChangeVO;
import nc.itf.uapbd.mate_change.mate_change_h.IMateChangeHVOService;

public class N_AMCA_APPROVE extends AbstractPfScriptAction<AggMateChangeVO>{
	
	public N_AMCA_APPROVE(){
		super();
	}
	
	@Override
	protected Object process(PfParameterVO paraVO) throws BusinessException {
		try {
			IMateChangeHVOService service = NCLocator.getInstance().lookup(IMateChangeHVOService.class);
			AggMateChangeVO[] vos = (AggMateChangeVO[])this.getVos();
			Arrays.stream(vos).forEach(v-> v.getParent().setStatus(VOStatus.UPDATED));
			
			IWorkFlowRet  workFlowRet = (IWorkFlowRet)this.procActionFlow(paraVO);
			
			vos = service.callbackAPPROVE(vos);
			
			return workFlowRet==null?vos:workFlowRet;
		}catch(Exception ex) {
			if (ex instanceof BusinessException) {
		        throw (BusinessException) ex;
		      }
	        throw new PFBusinessException(ex.getMessage(), ex);
		}
	}
	
	protected void before(PfParameterVO paraVO)  throws BusinessException{
		AggMateChangeVO vo = (AggMateChangeVO)this.getVo();
		if(StringUtils.isEmpty(vo.getPrimaryKey())){
			throw new BusinessException("ǰδִб涯űҵ̶壬鶯ã");
		}
	}
}